#!/usr/bin/perl

use strict;
use warnings;

my @RANDOM_PASSWORD_USERS = qw(localmon remotemon);
my $ADMIN_USER = 'upsadmin';

my ($target, $template, $generated) = @ARGV;

my $GENERATED_DIR = $generated;
$GENERATED_DIR =~ s%/[^/]*$%%;

die "Caller must export CCLUB_SCRIPTS" unless (exists $ENV{CCLUB_SCRIPTS});

open TARGET, "<", $target or die "Could not open '$target' for reading";

my %passwords;
my ($line, $user, $pass);
while (defined(($line = <TARGET>))) {
    if ($line =~ /^\s*\[([a-zA-Z][a-zA-Z0-9]*)\]\s*$/) {
        $user = $1;
        undef $pass;
    } elsif ($line =~ /^\s*password\s*=\s*([a-zA-Z0-9\+\/_-]+)\s*$/) {
        $pass = $1;
    }

    if (defined($user) && defined($pass)) {
        $passwords{$user} = $pass;
    }
}

close TARGET;

foreach $user (@RANDOM_PASSWORD_USERS) {
    if (!exists $passwords{$user}) {
        $passwords{$user} = `dd if=/dev/urandom bs=1 count=9 2>/dev/null | base64`;
        die "Failed to generate password for '$user'" if ($? != 0);
        chomp $passwords{$user};
    }
}

if (!exists $passwords{$ADMIN_USER}) {
    system("$ENV{CCLUB_SCRIPTS}/get_credentials.sh", '--want', 'upsadminpass');
    die "Failed to fetch password for '$ADMIN_USER'" if ($? != 0);

    my $passfile = "$GENERATED_DIR/upsadmin.pass";
    $passwords{$ADMIN_USER} = `cat "$passfile"`;
    die "Failed to read password for '$ADMIN_USER'" if ($? != 0);
    chomp $passwords{$ADMIN_USER};
    unlink($passfile);
}

my $gid = getgrnam('nut');
die "Could determine gid for the nut group" unless (defined($gid));

open TEMPLATE, '<', $template or die "Could not open '$template' for reading";
umask(037);
open GENERATED, '>', $generated or die "Could not open '$generated' for writing";
chown 0, $gid, *GENERATED;

while (defined(($line = <TEMPLATE>))) {
    foreach $user (@RANDOM_PASSWORD_USERS, $ADMIN_USER) {
        $line =~ s/%%${user}password%%/$passwords{$user}/g;
    }
    print GENERATED $line;
}

close TEMPLATE;
close GENERATED;
